#I
import numpy as np #pour exponentiel
from matplotlib import pyplot as plt #tracé graphique

#définition de l'équation différentielle:
def F(f,x):
    return 1/(x+np.exp(f))
    
#génèse de la liste des x:
pas=0.0001
liste_x=np.arange(0,2.5,pas)


liste_f=[]
f=0 #condition initiale
liste_f.append(f)

for i in range(len(liste_x)-1):
    xi=liste_x[i]
    fp=F(f,xi)
    f=f+fp*pas
    liste_f.append(f)

plt.plot(liste_x,liste_f)
plt.show()

"""
Version sans numpy
Remarque : en raison du cumum des arrondis successifs, on a un point de plus
"""
#définition de l'équation différentielle:
def F(f,x):
    return 1/(x+exp(f))
    
#génèse de la liste des x:
pas=0.0001
liste_x=[]


liste_f=[]
f=0 #condition initiale
liste_f.append(f)
xi=0
liste_x.append(xi)

while xi<=2.5:
    fp=F(f,xi)
    f=f+fp*pas
    xi=xi+pas
    liste_x.append(xi)
    liste_f.append(f)


plt.plot(liste_x,liste_f)
plt.show()

from math import exp


#II
"""
Si on ne veut que les identifiants, c'est simple :
SELECT rid FROM historique WHERE pid=87

Si on veut la description des randonnées :
SELECT rando.* FROM
(SELECT rid FROM historique WHERE pid=87) AS t1
JOIN
rando
ON rando.id=t1.rid
"""