#I
"""
La dérivée s'écrit 1-e^x, qui est négative sur R+ (et nulle en 0)
On constate que f(0)=2 et que f tend vers -infini en +infini. f étant continue, on a nécessairement un unique 0 sur R+.
De plus, comme e>2, f(x)<x-2^x+3. On constate alors que f(3)<-1. On a donc un zéro sur [0,3]
"""
#on travaille en dichotomie sur [0,3]
from math import exp
def f(x):
    return x-exp(x)+3
    

m=0
M=3
while M-m>2*10**-7:
    mil=(m+M)/2
    if f(mil)>0:
        m=mil
    else:
        M=mil
print((m+M)/2)


#II
"""
Le plus grand nombre est 2^15-1 (15 car on a des entiers signés)
Or 2^10=10^3, donc 2^15~2^5*10^3~32000

"""